      program ratio
      integer nfiles, head, i, j, n, unita, short, long, out
      parameter(nfiles = 8, head = 8, unita = 2, out = 3)
      integer a1000(nfiles), nmax
      real zeta, pi
      character*15 files(2, nfiles)
c-----these are actually 1000 times the a values
      data a1000 /  500, 600, 700, 800, 900, 950, 990, 995 /
      data files /
     +			'K4000_5.ZETA',   'K1_5.LOW_N',
     +			'K1200_6.ZETA',   'K2_6.LOW_N',
     +			'K1200_7.ZETA',   'K3_7.LOW_N',
     +			'K1200_8.ZETA',   'K4_8.LOW_N',
     +			'K1200_9.ZETA',   'K9_9.LOW_N',
     +			'K4000_95.ZETA',  'K19_95.LOW_N',
     +                  'K10000_99.ZETA', 'K99_99.LOW_N',
     +                  'K4000_995.ZETA', 'K199_995.LOW_N' /

         pi = 4 * atan(1.0)
         do 1000 i = 1, nfiles
           short = 1
2468       if (short * (1000 - a1000(i)) .lt. 1000) then
               short = short + 1
               goto 2468
           endif
           short = short - 1
           long = 1
4680       if ( -(long**2) * 1e-6 * (1000 - a1000(i))**2
     +         * 16 * pi * log(long * (1000 - a1000(i))/1000.0)
     +         .lt. 1) then
               long = long + 1
               goto 4680
           endif
           long = long - 1
           print *,'Short  ',short,' Long =',long,' a =',a1000(i)

         open( unit = unita, file = files(1, i), status = 'old' )
         call skip(head, unita)
         if (.not. locate(short, unita)) stop

         open( unit = out, file = files(2, i), status = 'new')
         call title(a1000(i), out)

         do 500 j = short , 1, -1
            read( unita, *) n, zeta
            if (j .le. long) then
               write(out, '(1x, 5x, 1x, 16x, 1x, 1p, e16.8)')
     +           zeta / sqrt( - log ( -(n**2) * 1e-6
     +                        * (1000 - a1000(i))**2
     +                        * 16 * pi
     +                        * log(n * (1000 - a1000(i))/1000.0)
     +                              ) / n)
            else
               write(out,*)
            endif
            write(out, '(''+'', i5, 1p, 1x, e16.8)') n, zeta /
     +        sqrt(-2.0 * log(n * (1000 - a1000(i)) / 1000.0) / n)
500      continue

         close(unita)
         close(out)
         print *, 'Completed ',short,' values in file ',files(2, i)

1000  continue
      end
c-----------------------------------------------------------
      subroutine skip(lines, file)
      integer lines, file, i
      do 100 i = 1, lines
          read(file, *)
100   continue
      return
      end
c-------------------------------------------------------------
      logical function locate(n, file)
      integer n, file, ok, try
100   read(file, *, iostat = ok) try
      if (ok .eq. 0) then
          if (try .eq. n) then
               backspace(file)
               locate = .true.
               return
          else
               goto 100
          endif
      else
          locate = .false.
          return
      endif
      end
c---------------------------------------------------------
      subroutine title(a1000, file)
      integer a1000, file
      write(file, '(1x, a, a, i3, a)' )
     + 'This file contains logarithmic low n',
     + ' approximations with a = ', a1000, ' / 1000.'
      write(file, '(1x, a)' ) 'n         = from the a file'
      write(file, '(1x, 2a)' ) 'approx 1 =',
     +   ' zeta/(-2log[n(1 - a)]/n)^(1/2)'
      write(file, '(1x, 2a)' ) 'approx 2 =',
     +   ' zeta/(-log[n^2 (1 - a)^2 16 pi log[n(1 - a)]]/n)^(1/2)'
      write(file, '(/, 1x, a5, 2(1x, a16))')
     +           'n', 'approx 1', 'approx 2'
      write(file, '( 1x, a5, 2(1x, a16))')
     +           '----', '---------------', '--------------'
      return 
      end
c---------------------------------------------------------
