C Called from SUBROUTINE SOLVE only.
C Calls SUBROUTINE ROMCAS only.
C
      SUBROUTINE DIVROM(FX,X0,X,ANS,PREC,A,N,LAMBDA,
     &                  NROOTS,T1,T2,DIVFLG)
      INTEGER N,NFRMLA,NROOTS,DIVFLG,RCASE
      REAL FX,X0,X,ANS,PREC,A,LAMBDA,T1,T2,LIM,LIM1,LIM2,
     &     ABST1,ABST2,DUMMY,DUMMY2
      LOGICAL T1DIV,T2DIV
C      IF (N .EQ. 98) THEN
      IF ((N .EQ. 98) .AND. 
     &    (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
        WRITE(6,*)' DIVROM: X0 = ',X0,'  X = ',X
        WRITE(6,*)'         T1 = ',T1,' T2 = ',T2
        WRITE(6,*)'    DIVFLG = ',DIVFLG,' NROOTS = ',NROOTS
      END IF
C
C DIVFLG=-1 when one t used already and case of two t's;
C       = 0 when no t's used, no divisions yet;
C       = 1 when no more divisions pending.
      IF (DIVFLG) 2000,1000,3000
1000	GOTO (2900,100,200),NROOTS+1
100	CONTINUE
C Case of one real root.
        LIM1=ABS(T1)
C      IF (N .EQ. 98) THEN
      IF ((N .EQ. 98) .AND. 
     &    (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
      	WRITE(6,*)' CASE OF ONE REAL ROOT. LIM1 = ',LIM1
      END IF
      	IF (LIM1 .LT. X0) GOTO 2900	!No more divisions,  RCASE=0, DIVFLG=1
      	IF (LIM1 .GT. X) GOTO 3000	!No divisions (yet), RCASE=0
C      IF (N .EQ. 98) THEN
        IF ((N .EQ. 98) .AND. 
     &    (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
        WRITE(6,*)'C One real root. Must divide integration.'
      END IF
      	RCASE=1
      	CALL ROMCAS(RCASE,X0,LIM1,X,DUMMY,ANS,FX,PREC,A,N,LAMBDA)
        DIVFLG=1         !No more divisions pending.
      	GOTO 9999	 !RETURN
200	CONTINUE
C      WRITE(6,*)'C Case of two real roots'
        ABST1=ABS(T1)
        ABST2=ABS(T2)
C Define LIM1 < LIM2
      	LIM1=MIN(ABST1,ABST2)
      	LIM2=MAX(ABST1,ABST2)
      IF (LIM1 .GT. LIM2) STOP 'IN DIVROM 1: LIM1>LIM2, ERROR.'
      IF (LIM2 .LT. X0) GOTO 2900 	!No more divisions, RCASE=1, DIVFLG=1
      IF (LIM1 .GT. X) GOTO 3000  	!No divisions (yet), RCASE=0
C Must divide at least once. T1DIV & T2DIV, Booleans, show whether
C division by the t-roots is necessary.
      T1DIV=(X0 .LT. LIM1) .AND. (LIM1 .LT. X)  ! X0 < LIM1 < X
      T2DIV=(X0 .LT. LIM2) .AND. (LIM2 .LT. X)  ! X0 < LIM2 < X
C
      IF (T1DIV) THEN
      	IF (T2DIV) THEN
      		RCASE=2		!Both LIM1 & LIM2
            	CALL ROMCAS(RCASE,X0,LIM1,LIM2,X,ANS,FX,PREC,A,N,LAMBDA)
      		DIVFLG=1  !No more divisions pending.
      	ELSE
      		RCASE=1		!LIM1 only
      		CALL ROMCAS(RCASE,X0,LIM1,X,DUMMY,ANS,FX,PREC,A,N,LAMBDA)
      		DIVFLG=-1	!Only one root still pending for 
C				 succeeding calls of ROMDIV
      	END IF
      ELSE IF (T2DIV) THEN
      	RCASE=1			!LIM2 only, not LIM1
        CALL ROMCAS(RCASE,X0,LIM2,X,DUMMY,ANS,FX,PREC,A,N,LAMBDA)
      	DIVFLG=1		!No more divisions pending
      ELSE
      	STOP 'IN ROMDIV 2: CASES SHOULD BE EXHAUSTED!'
      END IF
      GOTO 9999			!RETURN
2000	CONTINUE
C Case of two roots & LIM1 already divisor in previous call to ROMDIV
        ABST1=ABS(T1)
        ABST2=ABS(T2)
      	LIM2=MAX(ABST1,ABST2)
      	IF (X0 .LT. LIM .AND. LIM .LT. X) THEN	! Last root to divide
      		RCASE=1		!LIM2 only
      	        CALL ROMCAS(RCASE,X0,LIM,X,DUMMY,ANS,FX,PREC,A,N,LAMBDA)
      		DIVFLG=1		!No more divisions pending
      		GOTO 9999		!RETURN
      	END IF
      	GOTO 3000
2900	CONTINUE
C Case of no more divisions left for succeeding calls of ROMBRG
C      WRITE(6,*)' DIVROM. NO MORE DIVISIONS LEFT. '
      	DIVFLG=1
3000	CONTINUE
C Case of no divisions (yet)
C      WRITE(6,*)' DIVROM. NO MORE DIVISIONS (YET). '
      	RCASE=0
      	CALL ROMCAS(RCASE,X0,X,DUMMY,DUMMY2,ANS,FX,PREC,A,N,LAMBDA)
9999	CONTINUE
C      WRITE(6,*)' DIVROM ENDS: RCASE = ',RCASE,'  DIVFLG = ',DIVFLG
C      WRITE(6,*)' LIM1,LIM2,LIM = ',LIM1,LIM2,LIM
      	RETURN
        END
