C This function calculates K(N) according to the prescription
C
C                          [1/2(N-2)]!
C               KN = ------------------------
C                    SQRT[(N-1)PI][1/2(N-3)]!
C
C   from Lindley, p.39, for the t-distribution.
C
C
      REAL FUNCTION KN(N)
      INTEGER N
      REAL AN,NUM,DEN,RTPI
C PARAMETER 
      PARAMETER (RTPI= 1.7724 53850 90551 60272 98167)
      AN=FLOAT(N)
      NUM=FACTRL(0.5*AN-1.0)
      DEN=RTPI*SQRT(AN-1.0)*FACTRL(0.5*(AN-3.0))
      KN=NUM/DEN
      RETURN
      END
