C The Romberg method of integration.  
C
      SUBROUTINE ROMBRG(FX,X0,X,INTGL,PREC,A,N,LAMBDA)
C      IMPLICIT REAL (A-H,O-Z)
      INTEGER NMAX,MOUNT,N,NM1,NINTVL,I,J,NCNT,GRDFLG,GRDFL2,FLAG,
     &        MODN,WRFLG,K
      REAL INTGL,LAMBDA,OLDLAM(200),OLDQ(200),INTGL0,INTGL1,R(11,11),
     &     FX,X0,X,PREC,PREC1,A,ALPHA,BETA,WIDTH,SUMM,Q,POWER2,QNEW
C COMMON /GRD/   is not needed, except for diagnostic printed.
      COMMON /GRD/ OLDLAM,OLDQ,NCNT
C In COMMON with REAL FUNCTION FX
      COMMON /FXFLAG/ FLAG
C In COMMON with SUBROUTINE QSIGNS
      COMMON /ROMQSN/ALPHA,BETA
      EXTERNAL FX,QNEW
C      IF (N .EQ. 98) THEN
      IF ((N .EQ. 98) .AND. 
     &    (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
        WRITE(6,*)' ROMBRG: X0=ALPHA = ',X0,'  X=BETA = ',X
      END IF
      NMAX=11
      NM1=N-1
      WIDTH=X-X0
      ALPHA=X0
      BETA=X
      R(1,1)=0.5*WIDTH*(FX(X0,A,N,LAMBDA)+FX(X,A,N,LAMBDA))
      DO 300 I=2,NMAX
      	NINTVL=2.0**(I-2)
      	SUMM=0.0
      	DO 200 K=1,NINTVL
      	  SUMM=SUMM+FX(X0+(K-0.5)*WIDTH,A,N,LAMBDA)
          IF (FLAG .EQ. 1) GOTO 210
      	  Q=X0+(K-0.5)*WIDTH
      	  IF (I .GT. 7) GOTO 199
C      IF (N .EQ. 98) THEN
      IF ((N .EQ. 98) .AND. 
     &    (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
       	  WRITE(6,*)'ROMBRG: T = ',Q,'  FX(T) = ',FX(Q,A,N,LAMBDA) 
      END IF
199	CONTINUE
200	CONTINUE
210     R(I,1)=0.5*(R(I-1,1)+WIDTH*SUMM)
        WIDTH=0.5*WIDTH
      	DO 250 J=2,I
          POWER2=4.0**(J-1)
          R(I,J)=(POWER2*R(I,J-1)-R(I-1,J-1))/(POWER2-1.0)
250	CONTINUE
C      IF (N .EQ. 98) THEN
      IF ((N .EQ. 98) .AND. 
     &    (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
       	  WRITE(6,*)'ROMBRG: R(I,I) = ',R(I,I)
      END IF
        INTGL0=QNEW(LAMBDA,R(I-1,I-1),A,N)
        INTGL1=QNEW(LAMBDA,R(I,I),A,N)
      	PREC1=ABS(INTGL1-INTGL0)
      	IF (PREC1 .LT. PREC) THEN
      	  NMAX=I
      	  GOTO 999
      	END IF
300   CONTINUE
C
C Write coarse grid to gridfile the first time desired precision is not
C reached.  This condition occurs when these statements are executed; 
C otherwise there is a jump to label 999.  GRDFLG monitors whether this
C condition has occurred before  (when GRDFLG = 1).  The coarse grid is
C printed at most once, if the  precision criterion fails. 
C
      IF (GRDFLG .NE. N) THEN
      PRINT *,' '
C
      PRINT *,'-------- IN ROMBRG. PRECISION NOT REACHED:'
      PRINT 5000,N-1,PREC,PREC1,NINTVL*2,LAMBDA
C        WRITE(7,*)
C        WRITE(7,*)'IN ROMBRG. PRECISION NOT REACHED.'
C        WRITE(7,*)'  N-1 = ',NM1,'  A = ',A
C        WRITE(7,*)'  LIMITS ARE ',X0,' TO ',X
C        WRITE(7,*)'NO. OF INTERVALS = ',NINTVL*2
C        WRITE(7,*)'PRECISION         = ',PREC1
C        WRITE(7,*)'PRECISION DESIRED = ',PREC
        GRDFLG=N
C      	 WRFLG=MOD(N,45)
C      	 IF (WRFLG .EQ. 0) WRITE(7,2000)(OLDLAM(I),OLDQ(I),I=1,NCNT)
C        WRITE(7,*)
C        WRITE(7,*)'-------- IN ROMBRG. PRECISION NOT REACHED:'
C        WRITE(7,*)'   N   PREC.DESIRED   PREC.ATTAINED   NO.INTERVALS'
C        WRITE(7,2000)(OLDLAM(I),OLDQ(I),I=1,NCNT)
      END IF
C      PRINT *,' '
C
C      PRINT *,'-------- IN ROMBRG. PRECISION NOT REACHED:'
C      PRINT 5000,N-1,PREC,PREC1,NINTVL*2,LAMBDA
C
C      PRINT *,'-------- '
C      IF (N .LT. 7) PRINT *,N,PREC,PREC1,NINTVL*2
C      IF (N .LT. 7) WRITE(7,*) N,PREC,PREC1,NINTVL*2
C
C Later let INTGL=INTGL1, or name INTGL1 as INTGL.
999   INTGL=R(NMAX,NMAX)
C Write old coarse grid if n=1,2,3,10,50,100,200,300,400 . . .
C to gridfile (*.grd).
C      IF (GRDFLG .EQ. N) GOTO 9999
CC      IF (N .GT. 1) THEN
C      IF ((GRDFL2 .GT. NM1) .OR. (GRDFL2 .EQ. 0)) THEN
CC        MODN=MOD(NM1,100)
CC        IF ((MODN .EQ. 0) .OR. (NM1 .EQ. 50) .OR. 
CC     &     (NM1 .EQ. 10) .OR. (NM1 .LT. 4 ))  THEN
CC                PRINT *,N,PREC,PREC1,NINTVL*2
C      		WRITE(7,*)'  N-1 = ',NM1,'   A = ',A
C      		WRITE(7,*)
C      		WRITE(7,2000)(OLDLAM(I),OLDQ(I),I=1,NCNT)
C        	GRDFL2=NM1
CC        END IF
C      END IF
CC      END IF
C
C      IF ((N .EQ. 490) .OR. (N .EQ. 100) .OR. 
C     &     (N .EQ. 50) .OR. (N .EQ. 10 ) .OR. (N .EQ. 3 ))  THEN
C                PRINT *,N,PREC,PREC1,NINTVL*2,LAMBDA
C      END IF
9999  CONTINUE
C      IF (N .EQ. 98 .OR. N .EQ. 50 .OR. N .EQ. 18 .OR. N .EQ. 2)
C     &    PRINT 5010,N-1,X0,X,PREC,PREC1,NINTVL*2,LAMBDA,INTGL
      RETURN
2000    FORMAT(' ',200(/2F26.12))
5000	FORMAT(' ROM:',I5,2G16.8,5X,I6,5X,G16.8)
5010	FORMAT(' ROM:',I5,4G16.8,5X,I6,2G16.8)
      END
