C Called from SUBROUTINE SOLVE only.
C Calls no subprograms.
C
      SUBROUTINE TROOT(N,ZETA,LAMBDA,DDELTA,NROOTS,NFRMLA,T1,T2)
C
      INTEGER NROOTS,NFRMLA,N
      REAL*4 T0,T1,T2,TF,ZETA,LAMBDA,DELTA,RN,RL,Z,D,FACTOR,DIV,GN 
      REAL*8 DDELTA
C Three STATEMENT FUNCTIONS follow for intermediate calculations.
      FACTOR(RN)=SQRT(RN*(RN+1.0))
      DIV(RN)=(RN-1.0)/RN
      GN(Z,RN,RL,D)=Z*SQRT((RN+1.0)*RL*RL+DIV(RN)*D)
C
      DELTA=REAL(DDELTA)
      RN=REAL(N)
      GOTO (500,1000,2000,3000,1000), NFRMLA+1
500   CONTINUE
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
      		WRITE(6,*)'TROOT: NO REAL ROOTS. NFRMLA = ',NFRMLA
      		WRITE(6,9000) DELTA,N,LAMBDA,ZETA
          END IF
      RETURN                  			! No real roots.
1000  CONTINUE
      T0=GN(ZETA,RN,LAMBDA,DELTA) 		! Formula No. 1
      TF=FACTOR(RN)
      T1=(LAMBDA-T0)*TF/DELTA
      IF (NFRMLA .EQ. 4) GOTO 4000		!  goto Formula No. 4
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
      		WRITE(6,*)'TROOT: ONE REAL ROOT. NFRMLA = ',NFRMLA
      		WRITE(6,9000) DELTA,N,LAMBDA,ZETA,T1
          END IF
      RETURN
2000  CONTINUE
      T1=-ZETA*SQRT(DIV(RN))*FACTOR(RN)/SQRT(DELTA)	! Formula No. 2
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
      		WRITE(6,9000) DELTA,N,LAMBDA,ZETA,T1
          END IF
      RETURN
3000  CONTINUE
      T1=LAMBDA*LAMBDA-ZETA*ZETA*DIV(RN)*FACTOR(RN)/(2.0*LAMBDA) !Formula No. 3
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
      		WRITE(6,9000) DELTA,N,LAMBDA,ZETA,T1
          END IF
      RETURN
4000  CONTINUE
      T2=(LAMBDA+T0)*TF/DELTA		! Formula No. 4 after No.1 evaluated 
      IF (T2 .GT. T1) STOP 'IN TROOT: T2>T1, impossible!'
          IF ((N .EQ. 98) .AND. 
     &      (ABS(LAMBDA-0.3078975E-02) .LT. 0.1E-07)) THEN 
      		WRITE(6,9000) DELTA,N,LAMBDA,ZETA,T1,T2
          END IF
      RETURN
9000	FORMAT(' DELTA = ',G15.7,' N = ',I4,' LAMBDA = ',G15.7,' ZETA =
     &  ',G15.7,'T1 = ',G15.7,'T2 = ',G15.7)
      END
